function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import * as React from 'react';
import DownscreenContext, { initialState } from "./DownscreenContext.js";
import useEffectAfterMount from "./useEffectAfterMount.js";
import getFirstPossibleIndex from "./getFirstPossibleIndex.js";
import getLastPossibleIndex from "./getLastPossibleIndex.js"; // TODO: extract custom hooks, break them down by domain
// TODO: clean up state management (useReducer), memoize more for better performance (useMemo)

var Downscreen = function Downscreen(_ref) {
  var children = _ref.children,
      _ref$onSelect = _ref.onSelect,
      onSelect = _ref$onSelect === void 0 ? function () {} : _ref$onSelect,
      _ref$initial = _ref.initial,
      initial = _ref$initial === void 0 ? initialState : _ref$initial,
      totalCount = _ref.totalCount,
      id = _ref.id,
      className = _ref.className,
      style = _ref.style;
  var menuItemsRef = React.useRef({});

  var _React$useState = React.useState(initial),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  var value = React.useMemo(function () {
    return {
      state: state,
      setState: setState,
      totalCount: totalCount,
      id: id,
      getMenuItemsRef: function getMenuItemsRef() {
        return menuItemsRef;
      }
    };
  }, [state, totalCount, id]);
  useEffectAfterMount(function () {
    if (state.isOpen) {
      switch (state.lastKeyOnClose) {
        case 'ArrowUp':
          {
            setState(function (s) {
              return _objectSpread({}, s, {
                highlightedIndex: getLastPossibleIndex(totalCount, menuItemsRef.current),
                lastKeyOnClose: null
              });
            });
            break;
          }

        case 'ArrowDown':
          {
            setState(function (s) {
              return _objectSpread({}, s, {
                highlightedIndex: getFirstPossibleIndex(totalCount, menuItemsRef.current),
                lastKeyOnClose: null
              });
            });
            break;
          }
      }
    }
  }, [state.isOpen]);
  useEffectAfterMount(function () {
    onSelect(state.selectedIndex);
  }, [state.selectedIndex]);
  return React.createElement(DownscreenContext.Provider, {
    value: value
  }, React.createElement("div", {
    id: id,
    role: "combobox",
    "aria-haspopup": "listbox",
    "aria-expanded": state.isOpen,
    "aria-controls": state.isOpen ? "".concat(id, "-menu") : undefined,
    "aria-owns": state.isOpen ? "".concat(id, "-menu") : undefined,
    "aria-labelledby": "".concat(id, "-label"),
    className: className,
    style: style
  }, children));
};

export default Downscreen;