function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from 'react';
import DownscreenContext from "./DownscreenContext.js";

var Menu = function Menu(_ref) {
  var children = _ref.children,
      props = _objectWithoutProperties(_ref, ["children"]);

  var _React$useContext = React.useContext(DownscreenContext),
      state = _React$useContext.state,
      totalCount = _React$useContext.totalCount,
      id = _React$useContext.id;

  var menuChildren = React.useMemo(function () {
    return Array.from({
      length: totalCount
    }, function (_, index) {
      return children({
        index: index,
        selectedIndex: state.selectedIndex,
        highlightedIndex: state.highlightedIndex,
        inputValue: state.inputValue
      });
    });
  }, [state.selectedIndex, state.highlightedIndex, state.inputValue]);
  return state.isOpen ? React.createElement("div", _extends({
    id: "".concat(id, "-menu"),
    role: "listbox"
  }, props), menuChildren) : null;
};

export default Menu;