function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from 'react';
import scrollIntoViewIfNeeded from 'scroll-into-view-if-needed';
import DownscreenContext from "./DownscreenContext.js";

var MenuItem = function MenuItem(_ref) {
  var index = _ref.index,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ["index", "children"]);

  var _React$useContext = React.useContext(DownscreenContext),
      state = _React$useContext.state,
      setState = _React$useContext.setState,
      id = _React$useContext.id,
      getMenuItemsRef = _React$useContext.getMenuItemsRef;

  var shouldScroll = React.useRef(true);
  var scrollRef = React.useRef(null);
  React.useEffect(function () {
    getMenuItemsRef().current = _objectSpread({}, getMenuItemsRef().current, _defineProperty({}, index, true));
    return function () {
      getMenuItemsRef().current = _objectSpread({}, getMenuItemsRef().current, _defineProperty({}, index, false));
    };
  }, []);
  React.useEffect(function () {
    if (state.highlightedIndex === index && shouldScroll.current && scrollRef.current) {
      scrollIntoViewIfNeeded(scrollRef.current, {
        scrollMode: 'if-needed',
        block: 'nearest',
        inline: 'nearest'
      });
    }

    if (!shouldScroll.current) {
      shouldScroll.current = true;
    }
  }, [state.highlightedIndex, index]);
  var onClick = React.useCallback(function () {
    setState(function (s) {
      return _objectSpread({}, s, {
        isOpen: false,
        selectedIndex: index,
        highlightedIndex: null,
        inputValue: typeof s.lastSelectedInputValue === 'string' && s.selectedIndex === s.highlightedIndex ? s.lastSelectedInputValue : s.inputValue
      });
    });
  }, [index]);
  var onMouseMove = React.useCallback(function () {
    if (state.highlightedIndex !== index) {
      shouldScroll.current = false;
      setState(function (s) {
        return _objectSpread({}, s, {
          highlightedIndex: index
        });
      });
    }
  }, [state.highlightedIndex, index]);
  var onMouseDown = React.useCallback(function (event) {
    event.preventDefault();
  }, []);
  return React.createElement("div", _extends({
    ref: scrollRef,
    "aria-selected": state.highlightedIndex === index,
    id: "".concat(id, "-menu-item-").concat(index),
    role: "option",
    onClick: onClick,
    onMouseMove: onMouseMove,
    onMouseDown: onMouseDown
  }, props), children);
};

export default MenuItem;