import * as React from 'react';

var useEffectAfterMount = function useEffectAfterMount(cb, deps) {
  var justMounted = React.useRef(true);
  React.useEffect(function () {
    if (!justMounted.current) {
      return cb();
    }

    justMounted.current = false;
  }, deps);
};

export default useEffectAfterMount;