import * as React from 'react';
export interface State {
    isOpen: boolean;
    selectedIndex: number | null;
    highlightedIndex: number | null;
    inputValue: string;
    lastSelectedInputValue: string | null;
    lastKeyOnClose: ' ' | 'Enter' | 'Escape' | 'ArrowUp' | 'ArrowDown' | null;
}
export interface MenuItemsRef {
    [key: string]: boolean;
}
export declare const initialState: {
    isOpen: boolean;
    selectedIndex: null;
    highlightedIndex: null;
    inputValue: string;
    lastSelectedInputValue: null;
    lastKeyOnClose: null;
};
declare const DownscreenContext: React.Context<{
    state: State;
    setState: React.Dispatch<React.SetStateAction<State>>;
    totalCount: number;
    id: string | undefined;
    getMenuItemsRef: () => React.MutableRefObject<MenuItemsRef>;
}>;
export default DownscreenContext;
